
class ::ProjectileCoinTest extends ProjectileThrowable
{
    damage = 100;
    radius = 500;
    speed = 1500;
    model = "models/weapons/w_models/w_baseball.mdl";
    fusetime = 1;

    function Spawn(position, rotation, velocity)
    {
        base.Spawn(position, rotation, velocity);
        projectile.SetTeam(0);
    }

    function OnExplode(projectile)
    {
        local coinPos = projectile.GetCenter();
        local team = shooter.GetTeam();

        local minDist = 100;
        local minPlayer = null;

        local teammatesAndSpies = [];

        foreach (player in GetPlayers())
            if (player.GetTeam() == team || player.InCond(TF_COND_DISGUISED))
            {
                teammatesAndSpies.push(player);
                local distance = (player.GetCenter() - coinPos).Length();
                if (distance <= minDist)
                {
                    minDist = distance;
                    minPlayer = player;
                }
            }

        if (!minPlayer)
            return;

        DebugDrawCircle(coinPos, Vector(255, 255, 255), 255, 100, true, 2)
        coinPos = minPlayer.GetCenter();
        minDist = 100;

        foreach (player in teammatesAndSpies)
            if ((player.GetCenter() - coinPos).Length() <= minDist)
                ApplyCoinBuff(player);
    }

    function ApplyCoinBuff(player)
    {
        printl(player)
    }
}

::VIPCivilian <- class extends VIPShared
{
    playerClass = TF_CLASS_SCOUT;
    maxHealth = 175;
    //abilityClasses = [AbilityOffhandCoin];
    abilityClasses = [];

    fakePrimarySlot = class extends CustomWeaponBase
    {
        baseclass = "tf_weapon_sniperrifle";
        viewmodel = "models/vip_julius/weapons/v_cane.mdl";
        worldmodel = "models/vip_julius/weapons/w_cane.mdl";
        baseid = 3;

        function OnSwitch()
        {
            charScript.FindAbility("AbilityOffhandCoin").SwapCoin(0);
            player.Weapon_Switch(charScript.weaponEntRealCane);
        }
    };

    fakeSecondarySlot = class extends CustomWeaponBase
    {
        baseclass = "tf_weapon_smg";
        viewmodel = "models/vip_julius/weapons/v_cane.mdl";
        worldmodel = "models/vip_julius/weapons/w_cane.mdl";
        baseid = 3;

        function OnSwitch()
        {
            charScript.FindAbility("AbilityOffhandCoin").SwapCoin(1);
            player.Weapon_Switch(charScript.weaponEntRealCane);
        }
    };

    fakeMeleeSlot = class extends CustomWeaponBase
    {
        baseclass = "tf_weapon_club";
        viewmodel = "models/vip_julius/weapons/v_cane.mdl";
        worldmodel = "models/vip_julius/weapons/w_cane.mdl";
        baseid = 3;

        function OnSwitch()
        {
            charScript.FindAbility("AbilityOffhandCoin").SwapCoin(2);
            player.Weapon_Switch(charScript.weaponEntRealCane);
        }
    };

    realCane = class extends CustomWeaponBase
    {
        baseclass = "tf_weapon_bat_wood";
        viewmodel = "models/vip_julius/weapons/v_cane.mdl";
        worldmodel = "models/vip_julius/weapons/w_cane.mdl";
        baseid = 648;
        maxAmmo = 3;

        lastAmmo = 3;

        function OnEquip()
        {
            weapon.AddAttribute("maxammo grenades1 increased", 3, -1);
            weapon.AddAttribute("particle effect vertical offset", 64, -1);

            AddTimer(-1, function()
            {
                local ammo = GetPropIntArray(player, "m_iAmmo", 4);
                if (ammo < lastAmmo)
                    for (local projectile = null; projectile = FindByClassnameWithin(projectile, "tf_projectile_stun_ball", player.EyePosition(), 100);)
                        if (projectile.GetOwner() == player)
                        {
                            ProjectileCoinTest().ShootAbs(
                                player,
                                null,
                                projectile.GetOrigin(),
                                projectile.GetAbsAngles(),
                                projectile.GetPhysVelocity());
                            projectile.Kill();
                            break;
                        }
                lastAmmo = ammo;
            });
        }

        /*function ConvertBallToCoin(projectile)
        {
            local items = [];
            for (local item = projectile.FirstMoveChild(); item != null; item = item.NextMovePeer())
            {
                SetPropBool(item, "m_bForcePurgeFixedupStrings", true);
                items.push(item);
            }
            foreach (item in items)
                item.Kill();
            projectile.ValidateScriptScope();
            projectile.SetModelSimple("models/vip_julius/weapons/w_coin.mdl");


            SetDestroyCallback(projectile, OnExplode.bindenv(projectile.GetScriptScope()));
        }*/
    };

    abilityInstanceOffhandCoin = null;

    weaponEntFakePrimary = null;
    weaponEntFakeSecondary = null;
    weaponEntFakeMelee = null;
    weaponEntRealCane = null;

    function Precache()
    {
        base.Precache();
        PrecacheSound("vip_v7/coin_throw_minicrits.mp3")
        PrecacheSound("vip_v7/coin_throw_resistance.mp3")
        PrecacheSound("vip_v7/coin_throw_speed.mp3")
    }

    function ApplyCharacter()
    {
        base.ApplyCharacter();

        weaponEntFakePrimary = ProvideCustomWeapon(player, fakePrimarySlot);
        weaponEntFakeSecondary = ProvideCustomWeapon(player, fakeSecondarySlot);
        weaponEntFakeMelee = ProvideCustomWeapon(player, fakeMeleeSlot);
        player.Weapon_Switch(weaponEntFakePrimary);
        player.Weapon_Switch(weaponEntRealCane = ProvideCustomWeapon(player, realCane));
        player.AddCustomAttribute("health regen", 3, -1);
        player.AddCustomAttribute("no double jump", 1, -1);
        player.AddCustomAttribute("move speed bonus", 0.8, -1);
    }
}
