::cane_pickup <- null;
::firstStart <- true;

class CanePickup
{
    pickup_ent = null;
    character = null;
    assignedPlayer = null;
    team = null;

    failTS = 0;
    failIsEnabled = false;

    constructor(model, origin, character, team, spawnEnabled = true)
    {
        this.character = character;
        this.team = team;

        pickup_ent = CreateByClassname("item_armor");
        pickup_ent.DispatchSpawn();
        //pickup_ent.SetModelSimple(model);
        pickup_ent.SetModelSimple("models/vip_mobster/weapons/w_typewriter.mdl");
        pickup_ent.SetAbsOrigin(origin - Vector(0, 0, 20));
        //pickup_ent.SetAbsOrigin(origin - Vector(0, 410, 20));
        pickup_ent.SetTeam(team);
        pickup_ent.SetSolid(SOLID_BBOX);
        pickup_ent.SetSize(Vector(-35, -35, -25), Vector(35, 35, 65));
        pickup_ent.ValidateScriptScope();
        pickup_ent.ConnectOutput("OnCacheInteraction", "OnCacheInteraction");
        SetPropInt(pickup_ent, "m_nRenderMode", 1);
        local scope = pickup_ent.GetScriptScope();
        scope.script <- this;
        scope.OnCacheInteraction <- OnCaneTouch.bindenv(this);
        cane_pickup = pickup_ent;

        if (spawnEnabled)
            EnablePickup();
        else
            DisablePickup();

        AddTimer(0.1, CaneTempFallback);

        OnGameEvent("vip_gone", function(player, params)
        {
            //if (player == assignedPlayer)
            RunWithDelay(1, DoCaneReset);
        });

        if (firstStart)
        {
            firstStart = false;
            RunWithDelay(0.1, PickFirstVIP);
        }
    }

    function PickFirstVIP()
    {
        local newVIP = RandomElement(GetPlayers(team));
        if (newVIP)
            DoCanePickup(newVIP);
    }

    function OnCaneTouch()
    {
        if (!assignedPlayer
                && (!activator.IsFakeClient() || activator.GetPlayerClass() != TF_CLASS_SNIPER)
                && activator.GetTeam() == pickup_ent.GetTeam())
            DoCanePickup(activator);
    }

    function DoCanePickup(player)
    {
        failTS = Time() + 110;
        assignedPlayer = player;
        ConvertToCustomCharacter(player, character);
        FireCustomEvent("vip_spawn", {
            userid = player.GetUserID()
        });
        DisablePickup();
    }

    function DoCaneReset()
    {
        assignedPlayer = null;
        EnablePickup();
        //local timeDelta = GetPropFloatArray(tf_gamerules, "m_flNextRespawnWave", TF_TEAM_BLUE) - Time();
        /*local timeDelta = isRoundSetup ? 0 : FindRespawnWaveTime();
        if (timeDelta <= 0.5)
            EnablePickup();
        else
        {
            SpawnCooldownHolgram(timeDelta);
            RunWithDelay(timeDelta, EnablePickup);
        }*/
    }

    function DisablePickup()
    {
        failIsEnabled = false;
        pickup_ent.DisableDraw();
        pickup_ent.SetSolid(SOLID_NONE);

        local entsToKill = [];
        for (local child = pickup_ent.FirstMoveChild(); child != null; child = child.NextMovePeer())
            entsToKill.push(child);
        foreach (ent in entsToKill)
            ent.Kill();
    }

    function SpawnCooldownHolgram(timeDelta)
    {
        pickup_ent.EnableDraw();
        pickup_ent.SetSolid(SOLID_NONE);
        SetEntityColor(pickup_ent, [255, 255, 255, 128]);

        local flag = SpawnEntityFromTable("item_teamflag", {
            origin = pickup_ent.GetOrigin() - Vector(0, 0, 75),
            flag_model = "models/empty.mdl"
            StartDisabled = "1"
            VisibleWhenDisabled = "0"
        });
        EntFireByHandle(flag, "ShowTimer", timeDelta.tostring(), -1, null, null);
        EntFireByHandle(flag, "Kill", "", timeDelta, null, null);
    }

    function EnablePickup()
    {
        if (failIsEnabled)
        {
            PrintWarning("Prevented excessive EnablePickup");
            return;
        }
        failIsEnabled = true;
        pickup_ent.EnableDraw();
        pickup_ent.SetSolid(SOLID_BBOX);
        SetEntityColor(pickup_ent, [255, 255, 255, 255]);

        EntFireByHandle(SpawnEntityFromTable("info_particle_system",
        {
            origin = pickup_ent.GetOrigin() - Vector(0, 0, 20),
            effect_name = "spellbook_major_burning",
            start_active = 1
        }), "SetParent", "!activator", -1, pickup_ent, pickup_ent);
    }

    function CaneTempFallback()
    {
        if (!pickup_ent || !pickup_ent.IsValid())
            return;
        local frame = GetPropInt(pickup_ent, "m_ubInterpolationFrame");
        pickup_ent.SetAbsAngles(pickup_ent.GetAbsAngles() + QAngle(0, 10, 0));
        SetPropInt(pickup_ent, "m_ubInterpolationFrame", frame);

        if (!failIsEnabled && !FindVIP(TF_TEAM_BLUE) && Time() > failTS) //todo kludge
        {
            printl("failsafe")
            DoCaneReset();
        }
    }

    function FindRespawnWaveTime()
    {
        local time = Time();
        local first = [time + 999, 0];
        local last = [time + 999, 0];
        local respawnTime;
        foreach (player in GetPlayers(team))
        {
            if (player.IsAlive())
                continue;
            respawnTime = GetPropFloatArray(tf_player_manager, "m_flNextRespawnTime", player.entindex()) - time + 0.2;

            if (abs(respawnTime - first[0]) < 2)
            {
                first[1]++;
            }
            else if (respawnTime > first[0])
            {
                if (respawnTime < last[0])
                    last[0] = respawnTime;
                last[1]++;
            }
            else
            {
                last[0] = first[0];
                last[1] = first[1];
                first[0] = respawnTime;
                first[1] = 1;
            }
        }
        local result = first[1] >= 3 ? first[0] : last[0];
        return result < 20 ? result : 10;
    }
}