Include("vip/gamemode/func_regenerate_custom.nut");
Include("vip/gamemode/capture_point_filtering.nut");
Include("vip/gamemode/cane_pickup.nut");
Include("vip/gamemode/outline.nut");
Include("vip/gamemode/compass.nut");
Include("vip/gamemode/announcer.nut");
Include("vip/gamemode/overtime.nut");

Convars.SetValue("tf_bot_reevaluate_class_in_spawnroom", "0");

::FindVIP <- function(team)
{
    foreach (player in GetPlayers(team))
        if (IsVIP(player))
            return player;
    return null;
}

::IsVIP <- function(player)
{
    return GetCustomCharacter(player) instanceof VIPShared;
}

function SpawnBlueCaneAt(targetname)
{
    local ent = FindByName(null, targetname);
    KillIfValid(cane_pickup);
    CanePickup("models/vip_julius/weapons/w_cane.mdl", ent.GetOrigin(), VIPMobster, TF_TEAM_BLUE, !FindVIP(TF_TEAM_BLUE));
}

OnGameEvent("clear_custom_character", function(player, params)
{
    if (IsVIP(player))
        FireCustomEvent("vip_gone", params);
});

OnGameEvent("player_spawn", function(player, args)
{
    if (GetUpcomingCustomCharacter(player) || GetCustomCharacter(player))
        return;
    local myClass = VIP_CLASS_CHARACTERS[player.GetPlayerClass()];
    if (myClass)
        ConvertToCustomCharacter(player, myClass);
})

/*OnGameEvent("player_death", function(player)
{
    local teammateVIP = FindVIP(player.GetTeam());
    if (teammateVIP)
        SetPropEntity(player, "m_hObserverTarget", teammateVIP);
})*/

OnGameEvent("post_inventory_application", function(player, args)
{
    if (GetUpcomingCustomCharacter(player) || GetCustomCharacter(player))
        return;
    local myClass = VIP_CLASS_CHARACTERS[player.GetPlayerClass()];
    if (myClass)
        ConvertToCustomCharacter(player, myClass);
})

function ShowVIPAnnotation(player)
{
    local vip = FindVIP(player.GetTeam());
    if (!vip || vip == player)
        return;
    local myPos = vip.GetOrigin() + Vector(0, 0, 100);
    SendGlobalGameEvent("show_annotation",
    {
        worldPosX = myPos.x,
        worldPosY = myPos.y,
        worldPosZ = myPos.z,
        id = 121,
        text = "VIP",
        lifetime = 6,
        follow_entindex = vip.entindex(),
        visibilityBitfield = 1 << player.entindex()
    });
}
OnGameEvent("player_spawn_post", ShowVIPAnnotation);
OnGameEvent("player_teleported", ShowVIPAnnotation);
